#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingborder'
require '/opt/yklook/swingtabpane'
require '/opt/yklook/swingtimer'
require '/opt/yklook/swingsound'

class CookTimer < YKLookMain

	def yki_size()
		return [480, 240]
	end

	def yki_title()
		return '^C}['
	end

	def yki_make_display()

		numString = [ 'O', 'P', 'Q', 'R', 'S',
						'T', 'U', 'V', 'W', 'X' ]

		btnClear  = YKLookButton.new( '<html></html>' )
		btnFive   = YKLookButton.new( '<html>T</html>' )
		btnThree  = YKLookButton.new( '<html>R</html>' )
		btnOne    = YKLookButton.new( '<html>P</html>' )
		btnAction = YKLookButton.new( '<html>Jn<br>~</html>' )

		btnClear .yk_set_preferred_size( 60, 60 )
		btnFive  .yk_set_preferred_size( 60, 60 )
		btnThree .yk_set_preferred_size( 60, 60 )
		btnOne   .yk_set_preferred_size( 60, 60 )
		btnAction.yk_set_preferred_size( 80, 60 )

		YKLookLabel.new( numString[0] ).yk_var( '@labMinHi' )
		YKLookLabel.new( numString[0] ).yk_var( '@labMinLo' )
		YKLookLabel.new( numString[0] ).yk_var( '@labSecHi' )
		YKLookLabel.new( numString[0] ).yk_var( '@labSecLo' )

		f48 = YKLookFont.new( 'Dialog', 'B', 48 )
		f40 = YKLookFont.new( 'Dialog', 'B', 40 )

		@labMinHi.yk_set_font( f48 )
		@labMinLo.yk_set_font( f48 )
		@labSecHi.yk_set_font( f40 )
		@labSecLo.yk_set_font( f40 )

		fn_set_color( 'black' )

		tabPan  = YKLookTabPane.new()
		baseBox = YKLookPanelBox.new( 'v' )
		ctrlPan = YKLookPanelFlow.new()
		dispPan = YKLookPanelFlow.new( )
		prefPan = YKLookPanelGridBag.new()
		sndPan  = YKLookPanelGridBag.new()
		diaPan  = YKLookPanelGridBag.new()
		basePan = YKLookPanelFlow.new()

		sndPan.yk_set_border( nil, 'Ǐʉ' )
		diaPan.yk_set_border( nil, 'Ĩ_CAO\' )

		gbc = { 'anchor' => 'W', 'gridx' => 0 }

		sndBtnNone   = YKLookRadioButton.new( 'Ȃ' )
		sndBtnPinpon = YKLookRadioButton.new( 's|@@' )
		sndBtnBubu   = YKLookRadioButton.new( 'uu[I' )
		sndGrp = YKLookButtonGroup.new( [sndBtnNone,sndBtnPinpon,sndBtnBubu] )
		sndGrp.yk_var( '@sndGrp' )
		sndPan.yk_add( sndBtnNone  , gbc )
		sndPan.yk_add( sndBtnPinpon, gbc )
		sndPan.yk_add( sndBtnBubu  , gbc )

		diaBtnNone = YKLookRadioButton.new( 'Ȃ@@@@@@@@' )
		diaBtnDisp = YKLookRadioButton.new( '@@@@@@@@' )
		diaBtnDisp.yk_var('@diaBtnDisp')
		diaGrp = YKLookButtonGroup.new( [diaBtnNone,diaBtnDisp] )
		diaPan.yk_add( diaBtnNone, gbc )
		diaPan.yk_add( diaBtnDisp, gbc )

		gbc['gridx'] = nil

		ctrlPan.yk_add( btnClear )
		ctrlPan.yk_add( YKLookLabel.new( '     ' ) )
		ctrlPan.yk_add( btnFive )
		ctrlPan.yk_add( btnThree )
		ctrlPan.yk_add( btnOne   )
		ctrlPan.yk_add( YKLookLabel.new( '     ' ) )
		ctrlPan.yk_add( btnAction )
		dispPan.yk_add( @labMinHi )
		dispPan.yk_add( @labMinLo )
		dispPan.yk_add( YKLookLabel.new( '' ) )
		dispPan.yk_add( @labSecHi )
		dispPan.yk_add( @labSecLo )
		dispPan.yk_add( YKLookLabel.new( 'b' ) )
		baseBox.yk_add( ctrlPan )
		baseBox.yk_add( YKLookBoxFiller.new( 0, 20 ) )
		baseBox.yk_add( dispPan )
		prefPan.yk_add( sndPan, gbc )
		prefPan.yk_add( YKLookLabel.new( '@@@' ), gbc )
		prefPan.yk_add( diaPan, gbc )
		tabPan .yk_add( baseBox, '@@' )
		tabPan .yk_add( prefPan, 'ݒ' )
		basePan.yk_add( tabPan )
		yk_add( basePan )

		tabPan.yk_set_selected_index( 0 )

		sndPinpon = YKLookSound.yk_from_file( "quiz1.aiff" )
		sndBubu   = YKLookSound.yk_from_file( "quiz2.aiff" )
		sndPinpon.yk_var( '@sndPinpon' )
		sndBubu  .yk_var( '@sndBubu'   )

		timWatch = YKLookTimerWatch.new().yk_var( '@timWatch' )
		timWatch.yk_set_total( 0 )
		timWatch.yk_set_updown( 'down' )
		timWatch.yk_set_label_min( [ @labMinHi, @labMinLo ] )
		timWatch.yk_set_label_sec( [ @labSecHi, @labSecLo ] )
		timWatch.yk_set_number_string( numString )

		btnClear .yk_set_listener( :fn_btn_clear  )
		btnFive  .yk_set_listener( :fn_btn_five   )
		btnThree .yk_set_listener( :fn_btn_three  )
		btnOne   .yk_set_listener( :fn_btn_one    )
		btnAction.yk_set_listener( :fn_btn_action )
		timWatch .yk_set_listener( :fn_watch      )
	end
	def fn_set_color( prm_color )
		@labMinHi.yk_set_fore( prm_color )
		@labMinLo.yk_set_fore( prm_color )
		@labSecHi.yk_set_fore( prm_color )
		@labSecLo.yk_set_fore( prm_color )
	end
	def fn_btn_clear( prm_event )
		fn_set_color( 'black' )
		@timWatch.yk_clear()
	end
	def fn_btn_five( prm_event )
		@timWatch.yk_add_total( 5 * 60 )
	end
	def fn_btn_three( prm_event )
		@timWatch.yk_add_total( 3 * 60 )
	end
	def fn_btn_one( prm_event )
		@timWatch.yk_add_total( 60 )
	end
	def fn_btn_action( prm_event )
		if @timWatch.yk_total() <= 0
			yk_show_dialog_message( nil, "Ԃw肵Ă" )
			return
		end
		if not @timWatch.yk_is_active()
			fn_set_color( 'black' )
			@timWatch.yk_set_trigger( [10,5] )
		end
		@timWatch.yk_switch()
	end
	def fn_watch( prm_event )
		fire = @timWatch.yk_fire()
		if fire == 0
			case @sndGrp.yk_selected_index()
				when 1 then @sndPinpon.yk_play()
				when 2 then @sndBubu  .yk_play()
			end
			fn_set_color( 'black' )
			if @diaBtnDisp.yk_is_selected()
				yk_show_dialog_message( nil, "w肳ꂽԂɂȂ܂" )
			end
		end
		if fire == 5
			fn_set_color( 'red' )
		end
		if fire == 10
			fn_set_color( 'blue' )
		end
	end

	def yki_laf_is_system()
		return false
	end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( CookTimer.new() )

#
# end of program
